import java.util.Enumeration;

class linkedList {
   linkedListEntry beginning;
   linkedListEntry end;
   int numelements;

   public void append(Object var1) {
      if (var1 == null) {
         throw new NullPointerException();
      } else {
         linkedListEntry var2 = new linkedListEntry(var1);
         ++this.numelements;
         if (this.end == null) {
            this.end = var2;
            this.beginning = var2;
         } else {
            this.end.next = var2;
            var2.prev = this.end;
            this.end = var2;
         }
      }
   }

   public void insertAfter(Object var1, Object var2) {
      if (var2 != null && var1 != null) {
         linkedListEntry var3 = this.getref(var1);
         if (var3 == null) {
            throw new NullPointerException();
         } else {
            ++this.numelements;
            linkedListEntry var4 = new linkedListEntry(var2);
            var4.next = var3.next;
            var4.prev = var3;
            if (var3 == this.end) {
               this.end = var4;
            } else {
               var3.next.prev = var4;
            }

            var3.next = var4;
         }
      } else {
         throw new NullPointerException();
      }
   }

   public void insertBefore(Object var1, Object var2) {
      if (var2 != null && var1 != null) {
         linkedListEntry var3 = this.getref(var1);
         if (var3 == null) {
            throw new NullPointerException();
         } else {
            ++this.numelements;
            linkedListEntry var4 = new linkedListEntry(var2);
            var4.next = var3;
            var4.prev = var3.prev;
            if (var3 == this.beginning) {
               this.beginning = var4;
            } else {
               var3.prev.next = var4;
            }

            var3.prev = var4;
         }
      } else {
         throw new NullPointerException();
      }
   }

   public void delete(Object var1) throws NullPointerException {
      if (var1 == null) {
         throw new NullPointerException();
      } else {
         linkedListEntry var2 = this.getref(var1);
         if (var2 == null) {
            throw new NullPointerException();
         } else {
            --this.numelements;
            if (var2 != this.beginning) {
               var2.prev.next = var2.next;
            } else {
               this.beginning = var2.next;
            }

            if (var2 != this.end) {
               var2.next.prev = var2.prev;
            } else {
               this.end = var2.prev;
            }
         }
      }
   }

   public Object previous(Object var1) {
      if (var1 == null) {
         throw new NullPointerException();
      } else {
         linkedListEntry var2 = this.getref(var1);
         if (var2 == null) {
            throw new NullPointerException();
         } else {
            return var2.prev.node;
         }
      }
   }

   public Object next(Object var1) {
      if (var1 == null) {
         throw new NullPointerException();
      } else {
         linkedListEntry var2 = this.getref(var1);
         if (var2 == null) {
            throw new NullPointerException();
         } else {
            return var2.next.node;
         }
      }
   }

   private linkedListEntry getref(Object var1) {
      if (this.beginning == null) {
         return null;
      } else {
         linkedListEntry var2 = this.beginning;

         while(var2.node != var1) {
            var2 = var2.next;
            if (var2 == null) {
               return null;
            }
         }

         return var2;
      }
   }

   public boolean isPresent(Object var1) {
      if (var1 == null) {
         throw new NullPointerException();
      } else {
         return this.getref(var1) != null;
      }
   }

   public synchronized Enumeration elements() {
      return new linkedListEnumerator(this);
   }
}
